progname=exercise_06_19
CC=g++
CFLAGS=-Wall -Wextra -Werror -g3

all: test1

$(progname): $(progname).o | .gitignore
	$(CC) $(CFLAGS)  $^  -o  $@

%.ii: %.cpp
	$(CC) -E  $(CFLAGS)  $<  -o $@

%.s: %.ii
	$(CC) -S $(CFLAGS) $<  -o $@

%.o: %.s
	$(CC) -c $(CFLAGS) $<  -o $@

.gitignore:
	echo $(progname) > $@

clean:
	rm -f *.ii *.s *.o *.out $(progname) .gitignore

test%: $(progname)
	./$(progname) < $@.in > $@.out || echo "Test 1 is executing..."
	diff $@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: $(progname).ii  $(progname).s
.SECONDARY: $(progname).ii  $(progname).s

